(function(){
var additionalData = [
["blank.html","(no title)",
"This is a dummy file provided as a sample.\nCONFIDENTIAL\n",0]
,["external.html","(no title)",
"CONFIDENTIAL\n",0]
,["history.html","Revision History",
"Revision History\n",0]
,["history.html","Version 5.0 2015-12-21",
"Version 5.0 2015-12-21\n",0]
,["history.html","Changed",
"Changed\n \t2.1 Using the Save Data of Other Applications \tRemoved nn::fs::ResultBadFormat, nn::fs::ResultVerificationFailed, and nn::fs::ResultOperationDenied from the list of errors handled by the application when accessing save data from other applications. \tRemoved the above return values from the package keywords as well.\n \t12.1.1 Card-Based Applications \tRemoved nn::fs::ResultNotFormatted, nn::fs::ResultBadFormat, nn::fs::ResultVerificationFailed, and nn::fs::ResultOperationDenied from the \"When Mounting Save Data Archives of Other Applications\" subsection. \tCorrected method for causing nn::fs::ResultNotFound in the \"When Mounting Save Data Archives of Other Applications\" subsection.\n \t12.1.2 Downloadable Applications \tRemoved nn::fs::ResultNotFormatted, nn::fs::ResultBadFormat, nn::fs::ResultVerificationFailed, and nn::fs::ResultOperationDenied from the \"When Mounting Save Data Archives of Other Applications\" subsection. \tCorrected method for causing nn::fs::ResultNotFound in the \"When Mounting Save Data Archives of Other Applications\" subsection.\n",0]
,["history.html","Version 4.0 2015-04-02",
"Version 4.0 2015-04-02\n",0]
,["history.html","Added",
"Added\n \t11 System Settings\n \t11.1 Referencing the User Profile\n \t11.2 Referencing the Language Setting\n",0]
,["history.html","Changed",
"Changed\n \t5.1 Prohibition of Transitioning to Sleep Mode During Initialization \tAdded the nn::pia::local::LocalNetwork::Startup function and nn::pia::session::Session::Startup function to the list of initialization functions during which the system must not transition to Sleep Mode.\n",0]
,["history.html","Version 3.0 2014-10-23",
"Version 3.0 2014-10-23\n",0]
,["history.html","Added",
"Added\n \t6.2 Applications That Use Join-in Features\n \t7.3 Handling Corrupted Add-On Content\n",0]
,["history.html","Changed",
"Changed\n \tOverall \tRevised the term \"CTR\" to \"Nintendo 3DS\" throughout, in order to inclusively refer to all systems in the Nintendo 3DS family.\n \t1 Introduction \tAdded explanation of how this document refers to different systems.\n \t3.6 Using the ImageDb Library \tMoved some ImageDb-related guidelines here. \tChanged section name from \"ImageDb Library\" to its current name.\n \t6 Internet Communication \tMoved \"Applications That Use CTR-NEX\" from chapter 6.5 to chapter 6.3.\n",0]
,["history.html","Version 2.0 2014-07-22",
"Version 2.0 2014-07-22\n",0]
,["history.html","Added",
"Added\n \t4.6 Accelerometer Calibration\n \t8.1 Applications That Use Mii Characters\n \t8.3 Using Additional Information From Mii Characters\n \t8.4 Handling Corruption in Mii Character Database\n \t8.5 Obtaining CFLStoreData from Non-CFL Libraries\n",0]
,["history.html","Changed",
"Changed\n \t7.1 Purchase Determination For Add-On Content \tIn the check procedure, revised the description of the tools used to delete Nintendo eShop accounts or delete rights to a data title containing purchased items.\n",0]
,["history.html","Version 1.0 2014-06-05",
"Version 1.0 2014-06-05\n",0]
,["history.html","Added/Changed",
"Added/Changed\n \tInitial version.\nCONFIDENTIAL\n",0]
,["player.html","(no title)",
"\t\n",0]
,["printpage.html","Page for Printing",
"CONFIDENTIAL\n",0]
,["search.html","Search Page",
"Search Page\nYou can search the documentation from this page. Enter keywords in the textbox below, and press Enter or click Search to search for them. Pages containing the keywords you entered will be retrieved. Note: Only pages containing all of the specified keywords will be retrieved.\n Search\nCONFIDENTIAL\n",0]
,["search_KB.html","Keyword Jump",
"Keyword Jump\nCONFIDENTIAL\n",0]
,["title.html","Nintendo 3DS Programming Precautions",
"Nintendo 3DS Programming Precautions\nVersion 5.0\n\tNintendo Confidential\n\tThe content of this document is highly confidential and should be handled accordingly.\n The content of this document cannot be duplicated, copied, reprinted, transferred, distributed, or loaned in whole or in part without the prior approval of Nintendo.\n This document contains confidential and proprietary information of Nintendo and is also protected under the copyright laws of the United States and foreign countries.\n No part of this document may be released, distributed, transmitted or reproduced in any form or by any electronic or mechanical means, including information storage and retrieval systems, without permission in writing from Nintendo.\n© 2015 Nintendo. All rights reserved.\n All company and product names in this document are the trademarks or registered trademarks of their respective companies.\nCONFIDENTIAL\n",0]
,["Pages/Page_50889342.html","1 Introduction",
"1 Introduction\nThis document is written for programmers working on applications for systems in the Nintendo 3DS family. It contains a number of precautions to be aware of during development.\nYou may use either method below to navigate the precautions and check whether any apply to your application.\n \tBy Keyword\tAllows you to check precautions by related keywords.\n \tBy Page\tAllows you to check precautions by the volume (general category) they are sorted into.\n",0]
,["Pages/Page_50889342.html#Anchor_50889342_h1_1","Referring to Different Systems",
"Referring to Different Systems\nThere are various lineups of systems in the Nintendo 3DS family, but in this document they are separated into the following categories.\n Figure 1-1 Classification of Systems in the Nintendo 3DS Family in this Document\n \tOverall \tSubcategory \tDevelopment Name \tProduct Name\n \tNintendo 3DS \tCTR \tCTR \tNintendo 3DS\n \tSPR \tNintendo 3DS XL\n \tFTR \tNintendo 2DS\n \tSNAKE \tSNAKE, KTR \tNew Nintendo 3DS\n \tCLOSER, RED \tNew Nintendo 3DS XL\nBecause the majority of requirements and recommendations in this document describe or result in the same behavior on all systems in the above table, as a basic rule this document uses the term for the largest overall category, and thereby refers to all the systems. Therefore, unless the chapter differentiates between systems, any section that refers to \"Nintendo 3DS\" refers to all systems in the Nintendo 3DS family, not just the Nintendo 3DS system. Pertaining to this, note that any text that mentions SD Cards refers also to microSD cards in the case of the New Nintendo 3DS and New Nintendo 3DS XL systems.\nThere are some exceptions, listed below.\n \tThere is no Circle Pad Pro accessory for the Nintendo 2DS, New Nintendo 3DS, or New Nintendo 3DS XL systems. \tStereoscopic display is not supported on the Nintendo 2DS.\nIn addition to this, note that any chapters that differentiate between CTR and SNAKE are using these terms to refer to the subcategories in the table above. There are also places where development names are used in order to show the different hardware attributes of the different systems.\nCONFIDENTIAL\n",0]
,["Pages/Page_50889351.html","5 StreetPass and Local Communication",
"5 StreetPass and Local Communication\n",0]
,["Pages/Page_50889351.html#PageId_50889382","5.1 Prohibition of Transitioning to Sleep Mode During Initialization",
"5.1 Prohibition of Transitioning to Sleep Mode During Initialization\nDo not transition to Sleep Mode while any of the following functions are performing initialization.\n \tnn::uds::CTR::Initialize from the CTR-SDK \tnn::dlp::CTR::FakeClient::Initialize from the CTR-SDK \tnn::dlp::CTR::Server::Initialize from the CTR-SDK \tnn::pia::local::UdsNode::Initialize from CTR-Pia \tnn::pia::local::LocalNetwork::Startup from CTR-Pia \tnn::pia::session::Session::Startup from CTR-Pia\nAll of these functions perform UDS library initialization. UDS library initialization conflicts with the background communication-related processing that occurs during transition to Sleep Mode, which may result in abnormal behavior. This means it is necessary to handle Sleep Mode transition as a mutually exclusive process versus calls to the functions above.\n Local communication\n UDS\n Initialization\n Sleep\n CTR-SDK\n nn::uds::CTR::Initialize function\n nn::dlp::CTR::FakeClient::Initialize function\n nn::uds::CTR::Server::Initialize function\n CTR-Pia\n nn::pia::local::UdsNode::Initialize function\n nn::pia::local::LocalNetwork::Startup function\n nn::pia::session::Session::Startup function\n",0]
,["Pages/Page_50889351.html#PageId_51548844","5.2 Applications Which Use StreetPass",
"5.2 Applications Which Use StreetPass\nDeletion of an application’s StreetPass box from StreetPass Management must not affect progress in the application, and must not cause any bugs (such as inability to resume StreetPass).\nUsers can delete the StreetPass box for any application at any time by selecting StreetPass Management from System Settings. However, because users must exit the application in order to launch StreetPass Management, it is impossible for an application’s StreetPass box to be deleted from StreetPass Management while the application is running. Therefore it is enough to have your application check whether its StreetPass box was deleted each time it starts.\n StreetPass\n StreetPass boxes\n StreetPass Management\nCONFIDENTIAL\n",0]
,["Pages/Page_50889411.html","3 Graphics",
"3 Graphics\n",0]
,["Pages/Page_50889411.html#PageId_50889522","3.1 Restriction on Repeated Per-Frame Alternation Between Significantly Different Luminance Values",
"3.1 Restriction on Repeated Per-Frame Alternation Between Significantly Different Luminance Values\nAlternating every frame between two colors with significantly different luminance values (such as in a flickering effect) will decrease the lifespan of the LCD module for the CTR system's LCD screens. Therefore, as much as possible, avoid the prolonged use of any such effect such that any single pixel on the screen experiences it continuously for one minute or longer. The \"significantly different luminance values\" stated here refer to differences where all three of the R, G, B components change by a value of 128 or larger.\nNintendo does not recommend exploiting the properties of the LCD module with the image technique of switching repeatedly between two colors to achieve a \"translucent\" effect. It is possible that the screen may appear to flicker when displaying such an effect if the response speed of the LCD module becomes faster than that of current CTR systems, due to changes in product specifications or the release of future CTR-compatible systems.\n Graphics\n LCD Module\n Alternating Display\n Changes in Brightness\n Luminance\n",0]
,["Pages/Page_50889411.html#PageId_53056625","3.2 Applications That Do Not Use Stereoscopic Display",
"3.2 Applications That Do Not Use Stereoscopic Display\nThe amount of energy consumed in stereoscopic display mode (NN_GX_DISPLAYMODE_STEREO) differs considerably from normal mode (NN_GX_DISPLAYMODE_NORMAL).\nBecause use of this feature affects the length of time the system is able to operate while running off battery only, it is prohibited to use stereoscopic display mode in applications that do not generate any stereoscopic images. For the same reason, we consequently recommend that applications use the normal mode when they are not generating stereoscopic images.\n Stereoscopic Display\n NN_GX_DISPLAYMODE_STEREO\n NN_GX_DISPLAYMODE_NORMAL\n Power consumption\n",0]
,["Pages/Page_50889411.html#PageId_53056241","3.3 Supporting Stereoscopic Display",
"3.3 Supporting Stereoscopic Display\nApplications that support stereoscopic display must use the nn::ulcd::CTR::StereoCamera-class functions to adjust stereoscopic parallax in response to user operation of the 3D depth slider. This is because, if the application does not use the nn::ulcd::CTR::StereoCamera class and instead implements an independent way of adjusting stereoscopic parallax, there is a possibility that the parallax adjustment may not behave as intended in future CTR-compatible systems. However, it is acceptable in the following cases for applications to either not use the nn::ulcd::CTR::StereoCamera-class functions, not allow parallax adjustment, or not be capable of changing parallax in response to user operations.\n \tStereoscopically displaying the following types of content for which the parallax cannot be altered with the 3D depth slider.\tContent that is generated in advance (pre-rendered video or photos)\tImages captured with the outer cameras\n \tCases where it is technically difficult to update the displayed parallax to match adjustments to the 3D depth slider, such as while the game is paused. (However, this is only permissible for a short period of time in a range that would not inconvenience the user). \tTemporarily not using stereoscopic display, as part of application progression. \tTaking content whose parallax cannot be adjusted and display it layered with content rendered in real time\nNintendo recommends not supporting the 3D depth slider in this case, because it is possible to create an unsettling stereoscopic image with a contradictory foreground-background relationship if the 3D depth slider only affects the object rendered in real time.\nThe fundamental purpose of the 3D depth slider is to account for variation among individual users in how much stereoscopic parallax can be viewed comfortably. It is not intended to provide application developers with more freedom or with an additional input interface. However, even if the effect is not completely identical to the Nintendo 3DS standard of parallax adjustment using the nn::ulcd::CTR::StereoCamera-class functions, it is acceptable to use the value of the 3D depth slider in the application so long as you use it for the purpose of adjusting some kind of effect related to stereoscopic display, such as in the following cases.\n \tImplementing stereoscopic display by applying parallax proportionate to the value of the 3D depth slider to one or more 2D layers. \tBlurring (defocusing) objects in the background or foreground to a degree depending on the value of the 3D depth slider.\nYou can get the value of the 3D depth slider with the nn::ulcd::CTR::Get3DVolume function. Also note that it is prohibited to compute the 3D depth slider value applied in the application by means other than the nn::ulcd::CTR::Get3DVolume function. (For example, back-calculating the 3D depth slider value from the amount of parallax is prohibited.) This is because implementations that use 3D depth slider values obtained by back-calculation may produce unintended values in future CTR-compatible systems.\n Stereoscopic Display\n 3D Depth Slider\n Parallax\n Pre-Rendered Video\n Outer Cameras\n nn::ulcd::CTR::StereoCamera Class\n nn::ulcd::CTR::Get3DVolume Function\n",0]
,["Pages/Page_50889411.html#PageId_53053588","3.4 Referencing the Stereoscopic Display Permission State",
"3.4 Referencing the Stereoscopic Display Permission State\nYou can use the nn::gx::CTR::IsStereoVisionAllowed function to check whether stereoscopic display is currently permitted, but if you change application behavior in response to this permission state, you must only change behavior or features that are related to stereoscopic display. Also note it is prohibited to use the nngxSetDisplayMode function to change the display mode of the upper screen in response to the result returned by nn::gx::CTR::IsStereoVisionAllowed. This is because the nngxSetDisplayMode function is linked with illumination of the 3D LED, and the 3D LED is intended to inform the user of scenes where stereoscopic display is possible—not to reflect whether stereoscopic display is currently permitted.\nThe following are examples of acceptable changes to application behavior in response to the stereoscopic display permission state:\n \tNot allowing users to select modes that use the outer cameras to take 3D photos if stereoscopic display is not permitted. \tPlaying a sound effect when the permission state changes. \tAdding a visual effect to the appearance of the application, without affecting any of the application's content.\nIn contrast, the following are examples of prohibited processing:\n \tUsing the nngxSetDisplayMode function to change the display mode of the upper screen based on the stereoscopic display permission state. \tUsing switching of the stereoscopic display permission state as a input method for controlling an in-game character. \tChanging the strength of an enemy based on the permission state.\n Stereoscopic Display\n 3D LED\n Display Mode\n nn::gx::CTR::IsStereoVisionAllowed Function\n nngxSetDisplayMode Function\n",0]
,["Pages/Page_50889411.html#PageId_51544409","3.5 Implementations That Disable Updating of Right-Eye Buffer When Stereoscopic Display is Not Permitted",
"3.5 Implementations That Disable Updating of Right-Eye Buffer When Stereoscopic Display is Not Permitted\nIf your application implements a means of reducing the processing load by not updating the right-eye buffer when the 3D depth slider is set to \"off\" or when stereoscopic display is restricted by Parental Controls, then your application must not cause inappropriate stereoscopic display if the user transitions to the HOME Menu and the permission state changes to allow stereoscopic display. \"Inappropriate stereoscopic display,\" as mentioned here, results from a large difference in content between the left-eye and right-eye buffers. For example, cases such as having a black screen for only one eye or having images of different scenes in the left-eye and right-eye buffers fall under this definition.\nSpecifically, you must handle the situation mentioned above by (for example) either copying the content of the left-eye buffer to the right-eye buffer or setting both buffers to a black screen before transitioning to the HOME Menu.\nYou can use the following steps to check whether the application is handling it properly.\n \tProgress to a scene where the application does not update the right-eye buffer. \tTurn the 3D depth slider off (move the 3D depth slider all the way down). \tPlay until what is displayed on the upper screen changes. \tPress the HOME Button and transition to the HOME Menu. \tTurn the 3D depth slider on (move the 3D depth slider all the way up). \tLaunch the built-in Game Notes applet and check the screenshot it took of the upper screen of the application.\n Stereoscopic Display\n 3D Depth Slider\n HOME Menu\n HOME Button\n",0]
,["Pages/Page_50889411.html#PageId_51548789","3.6 Using the ImageDb Library",
"3.6 Using the ImageDb Library\nNote the following cautions when using the ImageDb library. These cautions are also described in the ImageDb Programming Manual, which is included in the ImageDb package.\n \tIf you would normally save a stereoscopic screenshot but stereoscopic display is disabled, then save only a JPEG image for the screenshot. \tThe ImageDb library can also load images other than photos taken by Nintendo 3DS Camera. Therefore, you must take measures such as the following to ensure the normal operation of your application after loading images of dimensions other than 640x480.\tScale, trim, or otherwise transform the image to ensure it will display properly.\tDo not load images whose dimensions are not supported by the application.\n \tWhen saving a screenshot within an application, use the imgdb::JpegMpBaseSaver::SetScreenshotFlag function to set the screenshot flag to true so that the screenshot is displayed by the “Games” slide show theme in Nintendo 3DS Camera.\n Note:\n The screenshot flag should be set to false with the imgdb::JpegMpBaseSaver::SetScreenshotFlag function in any scene where it is impossible for objects unique to the application to be included in the image. Pure camera images fall under this category. However, if an object appears and disappears depending on timing during a scene where cameras are used, this should be interpreted as \"a scene where objects unique to the application can be included in the image,\" and you should use the imgdb::JpegMpBaseSaver::SetScreenshotFlag function to set the screenshot flag to true. An example for this is switching back and forth from AR display. You do not need to toggle the screenshot flag every time the object appears and disappears.\n Setting the screenshot flag is optional in cases where the application does not use a display buffer but instead saves an independent buffer as a JPEG file. When deciding whether to handle an image as a screenshot, base your decision on whether the user would naturally think of the image as a screenshot. For example, if the image in question is captured from a game with added text at the bottom, it would normally be considered a screenshot. If the image was a QR Code that was generated from information pulled from the same game that would most likely not be considered a screenshot.\n ImageDb Library\n Nintendo 3DS Camera\n Photos\n JPEG\n Screenshots\n Slide show\n imgdb::JpegMpBaseSaver::SetScreenshotFlag function\nCONFIDENTIAL\n",0]
,["Pages/Page_50889973.html","4 Input Devices",
"4 Input Devices\n",0]
,["Pages/Page_50889973.html#PageId_53056348","4.1 Specifications Requiring Extreme Input",
"4.1 Specifications Requiring Extreme Input\nDue to the possibility of shortening the product lifetime or causing damage to the product, as well as leading to injury to the user, Nintendo recommends that applications do not require extended periods of extreme input when using the Touch Screen or other input devices, such as continuous, frequent, or excessive pressure on the input devices.\nIn particular, the START Button (as well as the SELECT and HOME Buttons) is not as durable of a button as it was on previous platforms, so specifications that make the user rapidly and repeatedly press the START button are prohibited. It is also prohibited to give some special effect to the act of pressing the START Button in short intervals such as double-clicking. We recommend that you not use the START Button as one of your application’s main operations, but as a means to pause, enter a menu screen, or perform some other supplementary role.\n Note:\n If your application is classified as a Virtual Console title, the prohibitions against rapidly pressing or double-clicking the START Button do not apply, because your application follows the original specifications.\n Input Devices\n Touch Screen\n START\n SELECT Button\n HOME Button\n Rapid and Repeated Pressing\n Virtual Console\n Product Lifetime\n Safety\n",0]
,["Pages/Page_50889973.html#PageId_53056476","4.2 Capturing Images with Outer Cameras for Use in Stereoscopic Display",
"4.2 Capturing Images with Outer Cameras for Use in Stereoscopic Display\nWhen the left and right outer cameras capture stereoscopic images, they must use the same settings: these include effects, the automatic exposure feature, and the frame rate. If the left and right outer cameras are configured differently, there is a possibility that a large discrepancy may occur between the left and right images, resulting in an inappropriate stereoscopic display. Inappropriate stereoscopic display may also result from the surrounding environment or from use of variable frame rate, but this is acceptable so long as the left- and right-camera settings are the same.\nOn the other hand, the following functions control the behavior of the automatic exposure and automatic white balance features to account for differences in the background between the left and right outer cameras. These functions deliberately set different values for the left and right outer cameras, so you do not need to set the same value for the left and right outer cameras using these functions.\n \tnn::camera::CTR::SetAutoExposureWindow function \tnn::camera::CTR::SetAutoWhiteBalanceWindow function\n Input Devices\n Outer Cameras\n Capture\n Stereoscopic Display\n nn::camera::CTR::SetAutoExposureWindow function\n nn::camera::CTR::SetAutoWhiteBalanceWindow function\n",0]
,["Pages/Page_50889973.html#PageId_51548513","4.3 Microphone Input Detection",
"4.3 Microphone Input Detection\nWhen detecting microphone input, you must take the guaranteed microphone input range and prohibited detection ranges into consideration. However, it is acceptable to ignore these ranges if you are using the microphone but not attempting to detect microphone input.\nThe upper and lower bounds of the guaranteed input ranges are defined as constants in nn::mic::CTR. Note that by default microphone input is clamped so as to use values within the guaranteed input range.\nYou can get the range(s) of values representing the prohibited detection range with the nn::mic::CTR::GetForbiddenArea function. If the microphone registers input values in this range, you must treat it as noise and not detect it as microphone input.\n Table 4-1 Guaranteed Microphone Input Range\n \tSampling Type \tGuaranteed Microphone Input Range\n \tSAMPLING_TYPE_8BIT \t27 to 228\n \tSAMPLING_TYPE_16BIT \t7105 to 58415\n \tSAMPLING_TYPE_SIGNED_8BIT \t-101 to +100\n \tSAMPLING_TYPE_SIGNED_16BIT \t-25663 to +25647\n Microphone\n Input Determination\n Guaranteed Input Range\n Prohibited Detection Ranges\n Noise Component\n nn::mic::CTR::GetForbiddenArea function\n Sampling Type\n SAMPLING_TYPE_8BIT\n SAMPLING_TYPE_16BIT\n SAMPLING_TYPE_SIGNED_8BIT\n SAMPLING_TYPE_SIGNED_16BIT\n",0]
,["Pages/Page_50889973.html#PageId_50890091","4.4 Preventing False Detection of Microphone Input",
"4.4 Preventing False Detection of Microphone Input\nTo avoid any problems, applications that use the microphone must implement some means of dealing with erroneous microphone input detection. You might use means similar to the following.\n \tDo not output sound through the speakers when the microphone is in use. \tProvide an option that lets the user adjust the microphone sensitivity. \tProvide an option that lets the user adjust the threshold used for microphone input detection.\nAcoustic feedback can occur if you continuously play back audio input from the microphone through the speakers in real time. This is not limited only to cases where audio taken as input to a Nintendo 3DS system's microphone is immediately played by speakers on that same system. It is also possible for feedback to occur during voice chat, when audio makes a round trip to the partner's Nintendo 3DS system before being played by speakers on the original system.\nYou must take some measure to prevent acoustic feedback if your application will be playing back audio input obtained from the microphone in real time for an extended period of time. Possible countermeasure 2 above, letting the user adjust the microphone sensitivity, can also be effective in preventing feedback.\n Microphone\n Erroneous Input\n Feedback\n Voice Chat\n",0]
,["Pages/Page_50889973.html#PageId_50890008","4.5 Gyro Sensor Power",
"4.5 Gyro Sensor Power\nIf the application creates one or more instances of the nn::hid::CTR::GyroscopeReader class, then the gyro sensor power turns on and consumes more power than when the gyro sensor power is off. Consequently, if the gyro sensor power is always on, the system battery life is reduced by about 2% to 3% when compared to always having it off.\nFor this reason, applications that do not use the gyro sensor must not create an instance of the nn::hid::CTR::GyroscopeReader class.\nEven for applications that use the gyro sensor, the nn::hid::CTR::GyroscopeReader class instance should be created, if possible, only just before using the gyro sensor. If possible, Nintendo also recommends deleting the instance of the nn::hid::CTR::GyroscopeReader class in scenes where the gyro sensor is not used. However, considering that gyro sensor sampling takes a maximum of about 160 ms to start after an instance of the nn::hid::CTR::GyroscopeReader class is created, there is no need to excessively create and delete instances in short intervals.\nStarting with the CTR-SDK 7.x series, you can check whether the application uses the gyro sensor by checking whether \"NINTENDO:Gyroscope\" is displayed in the list of middleware on the Master Editor's Basic Information (CCI) tab. If \"NINTENDO:Gyroscope\" is not displayed, the application does not use the gyro sensor at all.\n Gyro sensor\n nn::hid::CTR::GyroscopeReader Class\n Power consumption\n",0]
,["Pages/Page_50889973.html#PageId_55575129","4.6 Prohibition of Accelerometer Calibration",
"4.6 Prohibition of Accelerometer Calibration\nThe Nintendo 3DS system is equipped with a feature that allows users to calibrate the accelerometer zero point. You can use this feature any time the HOME Menu is displayed—even while an application is suspended—by holding down both the B Button and Y Button for 3 seconds. If the accelerometer zero point is calibrated from the HOME Menu, the values obtained from the nn::hid::CTR::AccelerometerReader class's Read and ReadLatest functions are corrected values.\nBecause this feature allows users to calibrate the accelerometer at any time they choose, applications must not implement their own independent accelerometer calibration. However, when accelerometer drift (particularly due to any short-term temperature changes) could have a major effect on application behavior, contact Nintendo at support@noa.com if there is a need for your application to implement its own independent calibration mode.\n Accelerometer\n Accelerometer drift\n Accelerometer zero point\n Calibration\n HOME Menu\n nn::hid::CTR::AccelerometerReader class\n nn::hid::CTR::AccelerometerReader::Read function\n nn::hid::CTR::AccelerometerReader::ReadLatest function\nCONFIDENTIAL\n",0]
,["Pages/Page_51548222.html","8 Mii Characters",
"8 Mii Characters\n",0]
,["Pages/Page_51548222.html#PageId_51548322","8.1 Applications That Use Mii Characters",
"8.1 Applications That Use Mii Characters\nEnsure that applications that use Mii characters can proceed without any problems even if there are no Mii characters in the front-end database.\nIf your application requires use of one or more Mii characters, it must handle the situation with one of the following methods when there are no Mii characters in the front end database.\n \tThe application displays a message immediately after application startup directing the user to create a Mii character using Mii Maker, and then suspends application progress until the user has created a Mii character. \tThe application starts using a default Mii character, a random Mii character, or a substitute image provided by the application.\nIn this case, Nintendo recommends displaying a message such as the following: \"There are no Mii characters available, so a substitute Mii will be used instead. You can create a new Mii in Mii Maker,\" or \"There are no Mii characters available. You can create a new Mii in Mii Maker.\"\n Mii Characters\n Front-end database\n Mii Maker\n",0]
,["Pages/Page_51548222.html#PageId_51548248","8.2 Prohibition of Altering Mii-Related Data",
"8.2 Prohibition of Altering Mii-Related Data\nIt is prohibited to alter the following data related to Mii characters.\n \tCFLStoreData \tThe Mii face model work buffer \tWork Buffer for the Intermediate Database \tPacket Buffer \tCFLNetInformation Buffer \tCFLAdditionalInfo \tOther CFL Structures\n Mii Characters\n CFL\n Prohibition of Altering\n CFLStoreData\n Face Model\n Intermediate Database\n Packet Buffer\n CFLNetInformation\n CFLAdditionalInfo\n",0]
,["Pages/Page_51548222.html#PageId_51548288","8.3 Using Additional Information From Mii Characters",
"8.3 Using Additional Information From Mii Characters\nIf your application uses additional information that pertains to a Mii character, ensure that the application can proceed without any problems even if a Mii character is used that has none of the following information configured.\n \tInformation \tMember of CFLAdditionalInfo\n \tCreator Name \tcreator\n \tMonth of birth \tbirthMonth\n \tDay of birth \tbirthDay\n Mii Characters\n Additional Information\n CFLAdditionalInfo\n",0]
,["Pages/Page_51548222.html#PageId_56756406","8.4 Handling Corruption in Mii Character Database",
"8.4 Handling Corruption in Mii Character Database\nIf the CFL_InitRes function is called when the Mii database is corrupted, the function will automatically initialize the database and return CFL_RESULT_FORMATTED to the application. If this happens, Nintendo strongly recommends informing the user that the database has been initialized by displaying the following or a similar message: \"Mii Maker save data was formatted due to data corruption.\"\nIf the Mii database has been initialized, then there will not be any Mii characters in the database. You must therefore comply with section 8.1 Applications That Use Mii Characters.\n Mii Characters\n Mii character database\n CFL_InitRes function\n CFL_RESULT_FORMATTED\n",0]
,["Pages/Page_51548222.html#PageId_51548329","8.5 Obtaining CFLStoreData from Non-CFL Libraries",
"8.5 Obtaining CFLStoreData from Non-CFL Libraries\nWhen passing the CFLStoreData of a Mii obtained with the friends library to any of the following functions, you must　always specify CFL_DATASOURCE_STOREDATA_ALWAYS for the source argument of the function.\n \tCFL_InitCharModel function \tCFL_MakeIcon function \tCFL_SetToNetPacket function \tCFL_GetAdditionalInfo function\nIf you specify CFL_DATASOURCE_STOREDATA instead of CFL_DATASOURCE_STOREDATA_ALWAYS in the source argument, this could cause the Mii character used in the application to look different from the Mii character in the friend list.\nIt is also possible for a friend’s Mii to be updated compared to what is in the friend list or deleted from the friend list in the HOME Menu even while the application is running. When an application gets a friend’s Mii character, it is acceptable to handle it as a friend’s Mii character even when the friend has been deleted from the friend list while the application is running.\nFurthermore, when using the friends library, it is possible to detect updates to a friend’s Mii character in real time. If such an update is detected, we recommend that the friend's Mii information being used by the application be updated as quickly as possible.\nYou can check whether the source argument is set correctly or not by preparing one system on which to run the application (System A) and one more system (System B), and then following the steps below.\n \tEstablish a friend relationship between System A and System B. \tUse Mii Maker to send System B's Mii to System A. \tLaunch Mii Maker on System B and alter the appearance of their Personal Mii. \tConfirm on System A's friend list that the appearance of System B's Mii has been altered. \tProgress through the application on System A, and confirm in a scene where a friend's Mii character is used that the appearance of System B's Mii is identical to that of their Mii in the friend list.\n Mii Characters\n Friends\n CFLStoreData\n CFL_DATASOURCE_STOREDATA_ALWAYS\n CFL_DATASOURCE_STOREDATA\n CFL_InitCharModel function\n CFL_MakeIcon function\n CFL_SetToNetPacket function\n CFL_GetAdditionalInfo function\n friends library\n Friend List\n",0]
,["Pages/Page_51548222.html#PageId_53057608","8.6 Nicknames of Friends' Mii Characters Obtained from Non-CFL Libraries",
"8.6 Nicknames of Friends' Mii Characters Obtained from Non-CFL Libraries\nThe nn::friends::CTR::GetFriendScreenName function provided in the friends library enables applications to obtain nickname of a friend’s Mii character without using CFL. The nickname of a friend's Mii character obtained with this function is basically the same as a nickname retrieved via CFL. However, if the creator of the friend's Mii is registered to the blocked-user list, then the CFL library will substitute “Mii” for the Mii nickname, whereas the friends library will not. Nintendo recommends getting nicknames of friends' Mii characters from CFLStoreData via the CFL library so the settings in the blocked-user list can also be applied.\nIn addition, nickname substitutions are performed in order to handle differences in Mii font regions and CTR system regions. These are carried out when true is specified for the replaceForeignCharacters argument of the nn::friends::CTR::GetFriendScreenName function.\n friends library\n Mii Characters\n Friends\n Nicknames\n nn::friends::CTR::GetFriendScreenName function\n Blocked-User List\n CFLStoreData\nCONFIDENTIAL\n",0]
,["Pages/Page_51548692.html","2 File System",
"2 File System\n",0]
,["Pages/Page_51548692.html#PageId_51548758","2.1 Using the Save Data of Other Applications",
"2.1 Using the Save Data of Other Applications\nWhen accessing the save data of other applications, the error codes returned when an error occurs may differ from the error codes returned when accessing your own application's save data.\nTherefore, you must implement the following error handling when accessing the save data of other applications.\n \tWhen nn::fs::ResultNotFound is returned:\n Inform the user that the save data being accessed may not have been created properly.\nExample message: \"Cannot find save data for (application being accessed). Please check whether the save data for (application being accessed) was created properly.\"\n \tWhen an unexpected error is returned:\nDo not process it as a fatal error, but inform the user that access to the save data failed.\nIf any of the above errors occurs, cancel the accessing of that save data. As long as you correctly handle the error first, it is acceptable to remount the save data later.\nIf your application accesses the save data for other applications in response to a user operation, you must notify the user that the application will access this other save data. If the application accesses such save data automatically, notifying the user is optional.\nSee the \"Save Data Archives (Other Programs)\" section in the Function Reference Manual for details on error handling.\n File System\n Save Data\n Save Data of Other Applications\n Error Handling\n nn::fs::ResultNotFound\nCONFIDENTIAL\n",0]
,["Pages/Page_51548803.html","10 Submission Stage Cautions",
"10 Submission Stage Cautions\n",0]
,["Pages/Page_51548803.html#PageId_51548826","10.1 Applications Not Using Join-In Features",
"10.1 Applications Not Using Join-In Features\nIf your application does not use join-in features, you must either specify no values for JoinGameID (join-in game ID) and JoinGameModeMask (join-in game mode mask) in the BSF file, or you must set these values to 0.\nTo check these values, check what is displayed for Join-in Game ID and Join-in Game Mode Mask in the CXI tab in Master Editor.\n Join-In Feature\n BSF File\n JoinGameID\n Join-In Game IDs\n JoinGameModeMask\n Join-in Game-Mode Mask\nCONFIDENTIAL\n",0]
,["Pages/Page_51548853.html","6 Internet Communication",
"6 Internet Communication\n",0]
,["Pages/Page_51548853.html#PageId_51550072","6.1 Implementation for Starting Connections",
"6.1 Implementation for Starting Connections\nThe Nintendo 3DS system may connect to the network independently from the application, via SpotPass or other communication features. Although it is possible to download data without going through the process of connecting to the network if the system is already connected, using Nintendo 3DS communication features in this way—without notifying system processes—will result in sudden disconnections and other unexpected behavior, because the system processes are responsible for managing Nintendo 3DS communication.\nFor this reason, the application must always start an Internet connection by calling either the nn::ac::CTR::Connect or nn::ac::CTR::ConnectAsync function.\nYou can use the following steps to check whether the application starts Internet connections by calling the functions listed above.\n \tIn System Settings, go to Internet Settings, then Connection Settings, and enter an incorrect SSID or security key for the access point you want to connect to. This puts the system in a state where communication features are usable, but the system cannot connect to the access point. \tIn the application, start an Internet connection. \tAn 003-10xx or 003-11xx error is displayed, indicating failure to connect to the access point.\n Internet Communication\n Internet Connections\n System Settings\n nn::ac::CTR::Connect function\n nn::ac::CTR::ConnectAsync function\n",0]
,["Pages/Page_51548853.html#PageId_60261244","6.2 Applications That Use Join-in Features",
"6.2 Applications That Use Join-in Features\nFor applications that use join-in features, Nintendo recommends explicitly logging in to a friend server by calling the nn::friends::Login function beforehand.\nIt is also possible to use join-in features after the system has logged into the friend server in the background, but we cannot guarantee that you will remain logged in unless the application performs the login itself.\n Internet Communication\n Join-In Feature\n Friend Server\n Logins\n nn::friends::Login Function\n",0]
,["Pages/Page_51548853.html#PageId_51550142","6.3 Applications That Use CTR-NEX",
"6.3 Applications That Use CTR-NEX\nIf your application uses CTR-NEX, use the unique codes (Game ID and Access Key) assigned separately to each application.\nYou can get unique codes from the Online title MAnagement System (OMAS), which is the website used to apply for network access.\n Internet Communication\n CTR-NEX\n Unique Codes\n Game ID\n Access Key\n OMAS\n",0]
,["Pages/Page_51548853.html#PageId_51550091","6.4 Timing of Display of Communication Errors",
"6.4 Timing of Display of Communication Errors\nIf the application detects an error in communication, display the error as soon as possible, at a time that does not inconvenience the user.\nHowever, there is no problem with notifying the user later if it does not disadvantage the user. Below are some examples.\n \tIf the application detects an error in communication that the user did not actively perform (for example, retrieving data in the background),\n→ display this error when the user attempts to use the data that otherwise would have been retrieved. \tIf the application detects a non-fatal, data-manipulation error (for example, corruption in data that is not required for progress in the game),\n→ display this error when the data is used. \tIf an error is detected during a cutscene or movie playback,\n→ display the error after the end of the cutscene or movie playback.\nConsult with Nintendo support if you cannot or do not wish to display errors immediately in cases other than the above. Nintendo will continue to add other examples to the above where the user is not inconvenienced.\nIf you have other methods by which you can tell ahead of time that an error will occur, it is acceptable to display the error beforehand.\n Internet Communication\n Communication Errors\n Displaying Errors\n",0]
,["Pages/Page_51548853.html#PageId_51548866","6.5 Using Dedicated Immediate-Execution Tasks in SpotPass",
"6.5 Using Dedicated Immediate-Execution Tasks in SpotPass\nBe aware of the following points if using a dedicated immediate-execution task with an application that uses SpotPass.\n \tSet Immediate Execution to “True” when filling out the form on OMAS. \tUse the nn::boss::RegisterImmediateTask function to register a task, and pass an instance of the nn::boss::FgOnlyTask class to the pTask argument. \tFor the download URLs, set URLs that are displayed by the BOSS data server.\nSpecifically, they must have the following format.\nhttps:://npdl.cdn.nintendowifi.net/p01/nsa/BossCode/FGONLYT/(Language)/ArchiveName \tUse the nn::boss::FgOnlyTask::StartImmediate function to run the task.\n SpotPass\n Immediate execution\n Dedicated Immediate-Execution Tasks\n OMAS\n nn::boss::RegisterImmediateTask function\n nn::boss::FgOnlyTask class\n nn::boss::FgOnlyTask::StartImmediate function\n",0]
,["Pages/Page_51548853.html#PageId_51548984","6.6 Using One-Time Immediate-Execution Tasks in SpotPass",
"6.6 Using One-Time Immediate-Execution Tasks in SpotPass\nWhen your application has a task that immediately executes a one-time download, and this task does not run again periodically, consider using a dedicated immediate-execution task.\nIf you do not use a dedicated immediate-execution task, delete the task once immediate execution has completed. Alternatively, set the task's execution count to \"1\" so that the task will run once and then be invalidated. For all task settings other than the execution count, set values that match the settings of a standard NADL task.\nYou can use the BossLotcheckTool to check to see if the task is deleted, or if the execution count for the registered task is now \"0\" and the task is invalid.\n SpotPass\n Immediate execution\n Dedicated Immediate-Execution Tasks\n",0]
,["Pages/Page_51548853.html#PageId_51550226","6.7 Initial Upload of Data to a CTR-NEX Data Store",
"6.7 Initial Upload of Data to a CTR-NEX Data Store\nAny data your application uploads to a data store will not be available to it when launched on other systems or initialized systems, because the PrincipalID of those systems will be different.\nAs a result, your application must always display a message when first uploading data with the data store features of CTR-NEX, informing the user that they cannot use the data on a different system, and that uploaded data will become unusable if they format the system memory. You must also always include such a description in the manual.\nHowever, if your application falls under the categories listed below, you do not need to display this message or include the description in the manual.\n \tApplications where the uploaded data cannot be viewed by the user later. \tApplications where deleting uploaded data does not adversely affect the game progress. \tDownload-only applications. (Downloaded applications can only run on the system to which they were downloaded, and if the system is initialized the save data for these applications—saved on the SD Card—also becomes unusable.)\n Internet Communication\n CTR-NEX\n Data Store Features\n Uploads\n PrincipalID\n",0]
,["Pages/Page_51548853.html#PageId_51550151","6.8 Connecting Only to Independent Servers Applied For on OMAS",
"6.8 Connecting Only to Independent Servers Applied For on OMAS\nIf your application supports network features, and it connects to servers other than those provided by Nintendo, only access (or link to) servers that you can control directly or indirectly. Use OMAS to apply for permission to access a server.\nIt is prohibited to access servers that have not been registered. Note that if Nintendo confirms that the application accesses an unregistered sever, Nintendo may suspend the network service.\n Internet Communication\n Independent Servers\n OMAS\n Prohibition Against Connecting\n Network-supported software\nCONFIDENTIAL\n",0]
,["Pages/Page_51549967.html","7 E-Commerce",
"7 E-Commerce\n",0]
,["Pages/Page_51549967.html#PageId_51550036","7.1 Purchase Determination For Add-On Content",
"7.1 Purchase Determination For Add-On Content\nAlways use the nn::ec::CTR::ContentInfo::IsOwned function to determine whether a particular add-on content item has been purchased.\nBecause the nn::ec::CTR::ContentInfo::IsOnDevice function determines whether add-on content exists on the SD card, it will return true as long as that content exists on the SD card, even if the system considers that content to be \"not purchased\".\nYou can use the following steps to check whether the purchase determination has been correctly handled.\n \tPrepare two SD cards (SD card A and SD card B).\nFor downloadable applications, download the application on to each SD card. \tPurchase an item, and save it to SD Card A. \tClose the application, and replace SD Card A with SD Card B. \tIn the purchase flow within the application, confirm that the item purchased in step 2 is displayed with some indication that it is purchased or that it is redownloadable. \tUse any of the following methods to delete the rights to the data title containing the item purchased in step 2, or simply delete the eShop account.\tIf your application does not use NNIDs (Nintendo Network IDs):\nUse EcDevTool (or EcRightTool) to delete the rights to the data title. Use the version of the tool included in the same CTR-SDK version used by your application.\tIf your application uses NNIDs:\nUse a version of EcDevTool from CTR-SDK 7.2.1 or later to delete the Nintendo eShop account.\n(Versions of EcDevTool prior to CTR-SDK 7.2.1 cannot delete Nintendo eShop accounts.)\n \tStill using SD Card B, display the item catalog in the purchase flow within the application. \tClose the application, and replace SD Card B with SD Card A. \tIn the purchase flow within the application, confirm that the item purchased in step 2 is displayed with some indication that it has not been purchased.\n Note:\n Always perform step 6 with SD Card B inserted. The EC applet might delete the contents of SD Card A if you insert SD Card A and check the item without following the procedure above.\n Error 009-1005 may sometimes occur upon download if you repurchase the same item after completing the entire procedure above, but this is by specification of the e-commerce system, and is not a problem with the application's implementation.\n E-Commerce\n Add-On Content\n Purchase determination\n NNID\n Nintendo Network ID\n EcDevTool\n EcRightTool\n Error 009-1005\n",0]
,["Pages/Page_51549967.html#PageId_51549983","7.2 Supporting Input of Item Download Codes in the Application",
"7.2 Supporting Input of Item Download Codes in the Application\nThe 16-digit item download code written on the item download voucher is composed of both alphabetic characters and numbers.\nFor this reason, if the user enters item download codes within the application, provide an input method that allows the user to enter both alphabetic characters and numbers.\n E-Commerce\n Item Download Codes\n",0]
,["Pages/Page_51549967.html#PageId_59483966","7.3 Handling Corrupted Add-On Content",
"7.3 Handling Corrupted Add-On Content\nIf add-on content gets corrupted, take care to ensure that this does not cause the application to lock up or prevent the user from progressing in the game. When you mount or load add-on content and discover that it is corrupted, display an error and return to the scene prior to accessing the add-on content. Alternatively, you can handle it in such ways as notifying the user of the fact that the add-on content could not be loaded, and then transitioning to a scene that does not use the add-on content.\nIf you discover that add-on content is corrupted when you call an e-commerce library function, handle it using nn::ec::ResultError, just like you would any other e-commerce library error. Likewise, when displaying errors other than SD Card insertion/removal errors, display the error code obtained with the nn::ec::ResultError::GetErrorCode function and the corresponding error message.\nNote that it is acceptable to not display an error or notification if the application discovers corruption in add-on content without actually mounting or loading the add-on content. (For example, in cases where the application uses the purchase simply to change a flag and unlock data that was embedded within the application from the start.)\nFor details about error handling, see the \"File System: Error Handling\" page in the E-Commerce library Function Reference.\nUse the following procedure to reproduce a situation where add-on content is corrupted.\n \tInsert the SD Card with the add-on content on it into a PC, open the pertinent APP file from the Nintendo 3DS/…/title/<ProgramID Hi32>/<ProgramID Lo32>/content/00000000 directory in a hex editor, and set the value for the first 4 bytes to 0. \tInsert the SD Card into a Nintendo 3DS, start the application, and go to the scene where the add-on content is loaded.\nIf your application performs error display for corrupted add-on content, then error code 009-4901 or 009-8111 will occur when you perform step 2.\n E-Commerce\n Add-On Content\n Corruption of Add-On Content\n Error Handling\n nn::ec::ResultError\n nn::ec::ResultError::GetErrorCode Function\n Error 009-4901\n Error 009-8111\nCONFIDENTIAL\n",0]
,["Pages/Page_51550379.html","12 Appendix",
"12 Appendix\n",0]
,["Pages/Page_51550379.html#PageId_51550458","12.1 How to Trigger File System Access Errors",
"12.1 How to Trigger File System Access Errors\nThis chapter outlines methods of triggering specific errors when accessing save data or other files, in order to check whether the application is handling these errors properly.\n",0]
,["Pages/Page_51550379.html#PageId_53051919","12.1.1 Card-Based Applications",
"12.1.1 Card-Based Applications\n",0]
,["Pages/Page_51550379.html#Anchor_53051919_h4_1","When Mounting CARD1 Save Data Archives",
"When Mounting CARD1 Save Data Archives\n \tError \tTrigger Method\n \tnn::fs::ResultNotFormatted \t Perform the following steps.\n \tInsert the Nintendo 3DS Game Card of the application being tested into a PARTNER-CTR Debugger. \tGo to CTR → Backup Device and open the Backup device of the CTR FLASH CARD dialog box. \tSelect Fill specified data in the backup memory, then select Reset the backup device to its factory default state in the drop-down. \tClick the Start button.\n \tnn::fs::ResultBadFormat \t Perform the following steps.\n \tInsert the Nintendo 3DS Game Card of the application being tested into a PARTNER-CTR Debugger. \tGo to CTR → Backup Device and open the Backup device of the CTR FLASH CARD dialog box. \tSelect Fill specified data in the backup memory, then select to invalidate the format of the backup device in the drop-down. \tClick the Start button.\n \tnn::fs::ResultVerificationFailed \t Perform the following steps.\n \tInsert the Nintendo 3DS Game Card of the application being tested into a PARTNER-CTR Debugger. \tGo to CTR → Backup Device and open the Backup device of the CTR FLASH CARD dialog box. \tSelect Write a file to backup memory (File -> Backup Device). For the File name of the file, specify 1MbitVerificationFailed.bin or 4MbitVerificationFailed.bin. These are special save data files that will return nn::fs::ResultVerificationFailed when mounted. \tClick the Start button.\n \tUnexpected Error \t(Under investigation)\n ",0]
,["Pages/Page_51550379.html#Anchor_53051919_h4_2","When Mounting CARD2 Save Data Archives",
"When Mounting CARD2 Save Data Archives\n \tError \tTrigger Method\n \tnn::fs::ResultNotFormatted \t(Under investigation)\n \tnn::fs::ResultBadFormat \t(Under investigation)\n \tnn::fs::ResultVerificationFailed \t Perform the following steps.\n \tLoad the CCI file of an application in a PARTNER-CTR Debugger unit. \t Execute the following commands in order to output the file: CTR → Card operations → Card emulation control → Backup area operations (CARD2) → Output backup data in emulation memory to file (Debugger->File). \tOpen the output file with a hex editor and tamper with the first 4 KB of data. \tIn PARTNER-CTR Debugger, execute Load file data into emulation memory backup region (File->Debugger), then launch the application.\n \tUnexpected Error \t(Under investigation)\n ",0]
,["Pages/Page_51550379.html#Anchor_53051919_h4_3","When Mounting Save Data Archives of Other Applications",
"When Mounting Save Data Archives of Other Applications\n \tError \tTrigger Method\n \tnn::fs::ResultNotFound \t Perform any of the following:\n \tUse SaveDataFiler to delete the relevant save data archive. \tRemove the media containing the relevant save data archive.\n ",0]
,["Pages/Page_51550379.html#Anchor_53051919_h4_4","When Mounting Extra Data Archives",
"When Mounting Extra Data Archives\n \tError \tTrigger Method\n \tnn::fs::ResultNotFound \t Perform any of the following:\n \tInsert an SD card that has just been formatted. \tDelete the extra data archive.\n \tnn::fs::ResultMediaNotFound \t Perform any of the following:\n \tRemove the SD card. \tInsert an empty miniSD adapter or microSD adapter into the SD Card slot.\n \tnn::fs::ResultNotFormatted \t Insert an SD card containing the application’s extra data into a computer. Delete the following directory or file on the SD Card.\n \tNintendo 3DS/…/extdata/<StorageID Hi32>/<StorageID Lo32>/00000000 (directory) \tNintendo 3DS/…/extdata/<StorageID Hi32>/<StorageID Lo32>/00000000/00000001\n \tnn::fs::ResultBadFormat \t(Under investigation)\n \tnn::fs::ResultVerificationFailed \t Insert an SD card containing the extra data into a computer. Open the following file on the SD card in a hex editor, and tamper with the first 4 KB of data.\n \tNintendo 3DS/…/extdata/<StorageID Hi32>/<StorageID Lo32>/00000000/00000001\n \tnn::fs::ResultOperationDenied \t Insert an SD card containing the application’s extra data into a computer. Set the following directory or file on the SD card to read-only.\n \tNintendo 3DS/…/extdata/<StorageID Hi32>/<StorageID Lo32>/00000000 (directory) \tNintendo 3DS/…/extdata/<StorageID Hi32>/<StorageID Lo32>/00000000/00000001\n \tnn::fs::ResultWriteProtected \tSlide the write-prevention tab on the SD card to \"lock\" the card.\n \tnn::fs::ResultMediaAccessError \tThis error occurs when hardware is the cause, such as when the media is making bad contact, but there is no way to reliably trigger it.\n \tnn::fs::ResultNotEnoughSpace \tMake the amount of free space on the SD card extremely low (TBD bytes or less available).\n \tUnexpected Error \t(Under investigation)\n ",0]
,["Pages/Page_51550379.html#Anchor_53051919_h4_5","When Mounting Write-Only sdmc Archives",
"When Mounting Write-Only sdmc Archives\n \tError \tTrigger Method\n \tnn::fs::ResultMediaNotFound \t Perform any of the following:\n \tRemove the SD card. \tInsert an empty miniSD adapter or microSD adapter into the SD Card slot.\n \tnn::fs::ResultBadFormat \t(Under investigation)\n \tnn::fs::ResultOperationDenied \t(Under investigation)\n \tnn::fs::ResultWriteProtected \tThis error does not occur.\n \tnn::fs::ResultMediaAccessError \tThis error occurs when hardware is the cause, such as when the media is making bad contact, but there is no way to reliably trigger it.\n \tUnexpected Error \t(Under investigation)\n ",0]
,["Pages/Page_51550379.html#Anchor_53051919_h4_6","When Operating on Files or Directories in Save Data Archives",
"When Operating on Files or Directories in Save Data Archives\n \tError \tTrigger Method\n \tnn::fs::ResultNotFound \t Perform the following steps.\n \tLaunch the application with its save data in the factory-default state, and complete the formatting of save data and creation of initial data. \tUse the SaveDataFiler tool to delete all of the save data files.\n \tnn::fs::ResultAlreadyExists \t(Under investigation)\n \tnn::fs::ResultVerificationFailed \t Use the SaveDataFiler tool to tamper with save data and cause an nn::fs::ResultVerificationFailed error to be returned during file and directory operations.\n Note: Depending on the state of the save data itself, it might not be possible to corrupt it using the SaveDataFiler tool.\n \tnn::fs::ResultOperationDenied \t(Under investigation)\n \tnn::fs::ResultMediaAccessError \tThis error occurs when hardware is the cause, such as when the media is making bad contact, but there is no way to reliably trigger it.\n \tnn::fs::ResultNotEnoughSpace \t(Under investigation)\n \tUnexpected Error \t(Under investigation)\n ",0]
,["Pages/Page_51550379.html#Anchor_53051919_h4_7","When Operating on Files or Directories in Extra Data Archives",
"When Operating on Files or Directories in Extra Data Archives\n \tError \tTrigger Method\n \tnn::fs::ResultNotFound \tUse SaveDataFiler to delete the file.\n \tnn::fs::ResultMediaNotFound \tThere is no way to reliably trigger this error.\n \tnn::fs::ResultAlreadyExists \t(Under investigation)\n \tnn::fs::ResultVerificationFailed \t Insert an SD card containing the extra data into a computer. Open the following file on the SD card in a hex editor, and tamper with the first 4 KB of data.\n \tAll files except 00000001 and 00000002 in the Nintendo 3DS/…/extdata/<StorageID Hi32>/<StorageID Lo32>/00000000 directory.\n \tnn::fs::ResultArchiveInvalidated \tRemove the SD card.\n \tnn::fs::ResultOperationDenied \t Insert an SD card containing the application’s extra data into a computer. Set the following directory or file on the SD card to read-only.\n \tNintendo 3DS/…/extdata/<StorageID Hi32>/<StorageID Lo32>/00000000 (directory) \tNintendo 3DS/…/extdata/<StorageID Hi32>/<StorageID Lo32>/00000000/00000001\n \tnn::fs::ResultWriteProtected \tSlide the write-prevention tab on the SD card to \"lock\" the card.\n \tnn::fs::ResultMediaAccessError \tThis error occurs when hardware is the cause, such as when the media is making bad contact, but there is no way to reliably trigger it.\n \tnn::fs::ResultNotEnoughSpace \tReduce the amount of free space on the SD card until it is less than the size of the file you are attempting to write.\n \tUnexpected Error \t(Under investigation)\n ",0]
,["Pages/Page_51550379.html#Anchor_53051919_h4_8","When Operating on Files or Directories in Write-Only sdmc Archives",
"When Operating on Files or Directories in Write-Only sdmc Archives\n \tError \tTrigger Method\n \tnn::fs::ResultNotFound \t(Under investigation)\n \tnn::fs::ResultMediaNotFound \t Perform any of the following:\n \tRemove the SD card. \tInsert an empty miniSD adapter or microSD adapter into the SD Card slot.\n \tnn::fs::ResultAlreadyExists \t(Under investigation)\n \tnn::fs::ResultArchiveInvalidated \tRemove the SD card.\n \tnn::fs::ResultOperationDenied \t(Under investigation)\n \tnn::fs::ResultWriteProtected \tSlide the write-prevention tab on the SD card to \"lock\" the card.\n \tnn::fs::ResultMediaAccessError \tThis error occurs when hardware is the cause, such as when the media is making bad contact, but there is no way to reliably trigger it.\n \tnn::fs::ResultNotEnoughSpace \tReduce the amount of free space on the SD card until it is less than the size of the file you are attempting to write.\n \tUnexpected Error \t(Under investigation)\n",0]
,["Pages/Page_51550379.html#PageId_53051949","12.1.2 Downloadable Applications",
"12.1.2 Downloadable Applications\n",0]
,["Pages/Page_51550379.html#Anchor_53051949_h4_1","When Mounting Save Data Archives",
"When Mounting Save Data Archives\n \tError \tTrigger Method\n \tnn::fs::ResultNotFormatted \tUse SaveDataFiler to delete the save data archive.\n \tnn::fs::ResultBadFormat \t(Under investigation)\n \tnn::fs::ResultVerificationFailed \t Insert an SD Card with the application into a computer. Open the following file on the SD Card in a hex editor and tamper with the first 4 KB of data.\n \tNintendo 3DS/…/title/<ProgramID Hi32>/<ProgramID Lo32>/data/00000001.sav\n \tUnexpected Error \t(Under investigation)\n ",0]
,["Pages/Page_51550379.html#Anchor_53051949_h4_2","When Mounting Save Data Archives of Other Applications",
"When Mounting Save Data Archives of Other Applications\n \tError \tTrigger Method\n \tnn::fs::ResultNotFound \t Perform any of the following:\n \tUse SaveDataFiler to delete the relevant save data archive. \tIf the relevant save data archive is on a Nintendo 3DS Game Card, remove the Game Card.\n ",0]
,["Pages/Page_51550379.html#Anchor_53051949_h4_3","When Mounting Extra Data Archives",
"When Mounting Extra Data Archives\n \tError \tTrigger Method\n \tnn::fs::ResultNotFound \tDelete the extra data archive.\n \tnn::fs::ResultMediaNotFound \t(Under investigation)\n \tnn::fs::ResultNotFormatted \t Insert an SD card containing the application’s extra data into a computer. Delete the following directory or file on the SD Card.\n \tNintendo 3DS/…/extdata/<StorageID Hi32>/<StorageID Lo32>/00000000 (directory) \tNintendo 3DS/…/extdata/<StorageID Hi32>/<StorageID Lo32>/00000000/00000001\n \tnn::fs::ResultBadFormat \t(Under investigation)\n \tnn::fs::ResultVerificationFailed \t Insert an SD card containing the extra data into a computer. Open the following file on the SD card in a hex editor, and tamper with the first 4 KB of data.\n \tNintendo 3DS/…/extdata/<StorageID Hi32>/<StorageID Lo32>/00000000/00000001\n \tnn::fs::ResultOperationDenied \t Insert an SD card containing the application’s extra data into a computer. Set the following directory or file on the SD card to read-only.\n \tNintendo 3DS/…/extdata/<StorageID Hi32>/<StorageID Lo32>/00000000 (directory) \tNintendo 3DS/…/extdata/<StorageID Hi32>/<StorageID Lo32>/00000000/00000001\n \tnn::fs::ResultWriteProtected \tSlide the write-prevention tab on the SD card to \"lock\" the card.\n \tnn::fs::ResultMediaAccessError \tThis error occurs when hardware is the cause, such as when the media is making bad contact, but there is no way to reliably trigger it.\n \tnn::fs::ResultNotEnoughSpace \tMake the amount of free space on the SD card extremely low (TBD bytes or less available).\n \tUnexpected Error \t(Under investigation)\n ",0]
,["Pages/Page_51550379.html#Anchor_53051949_h4_4","When Mounting Write-Only sdmc Archives",
"When Mounting Write-Only sdmc Archives\n \tError \tTrigger Method\n \tnn::fs::ResultMediaNotFound \t(Under investigation)\n \tnn::fs::ResultBadFormat \t(Under investigation)\n \tnn::fs::ResultOperationDenied \t(Under investigation)\n \tnn::fs::ResultWriteProtected \tThis error does not occur.\n \tnn::fs::ResultMediaAccessError \tThis error occurs when hardware is the cause, such as when the media is making bad contact, but there is no way to reliably trigger it.\n \tUnexpected Error \t(Under investigation)\n ",0]
,["Pages/Page_51550379.html#Anchor_53051949_h4_5","When Operating on Files or Directories in Save Data Archives",
"When Operating on Files or Directories in Save Data Archives\n \tError \tTrigger Method\n \tnn::fs::ResultNotFound \t Perform the following steps.\n \tLaunch the application with its save data in the factory-default state, and complete the formatting of save data and creation of initial data. \tUse the SaveDataFiler tool to delete all of the save data files.\n \tnn::fs::ResultAlreadyExists \t(Under investigation)\n \tnn::fs::ResultVerificationFailed \t Use the SaveDataFiler tool to tamper with save data and cause an nn::fs::ResultVerificationFailed error to be returned during file and directory operations.\n Note: Depending on the state of the save data itself, it might not be possible to corrupt it using the SaveDataFiler tool.\n \tnn::fs::ResultOperationDenied \t(Under investigation)\n \tnn::fs::ResultMediaAccessError \tThis error occurs when hardware is the cause, such as when the media is making bad contact, but there is no way to reliably trigger it.\n \tnn::fs::ResultNotEnoughSpace \t(Under investigation)\n \tUnexpected Error \t(Under investigation)\n ",0]
,["Pages/Page_51550379.html#Anchor_53051949_h4_6","When Operating on Files or Directories in Extra Data Archives",
"When Operating on Files or Directories in Extra Data Archives\n \tError \tTrigger Method\n \tnn::fs::ResultNotFound \tUse SaveDataFiler to delete the file.\n \tnn::fs::ResultMediaNotFound \tThere is no way to reliably trigger this error.\n \tnn::fs::ResultAlreadyExists \t(Under investigation)\n \tnn::fs::ResultVerificationFailed \t Insert an SD card containing the extra data into a computer. Open the following file on the SD card in a hex editor, and tamper with the first 4 KB of data.\n \tAll files except 00000001 and 00000002 in the Nintendo 3DS/…/extdata/<StorageID Hi32>/<StorageID Lo32>/00000000 directory.\n \tnn::fs::ResultArchiveInvalidated \t(Under investigation)\n \tnn::fs::ResultOperationDenied \t Insert an SD card containing the application’s extra data into a computer. Set the following directory or file on the SD card to read-only.\n \tNintendo 3DS/…/extdata/<StorageID Hi32>/<StorageID Lo32>/00000000 (directory) \tNintendo 3DS/…/extdata/<StorageID Hi32>/<StorageID Lo32>/00000000/00000001\n \tnn::fs::ResultWriteProtected \tSlide the write-prevention tab on the SD card to \"lock\" the card.\n \tnn::fs::ResultMediaAccessError \tThis error occurs when hardware is the cause, such as when the media is making bad contact, but there is no way to reliably trigger it.\n \tnn::fs::ResultNotEnoughSpace \tReduce the amount of free space on the SD card until it is less than the size of the file you are attempting to write.\n \tUnexpected Error \t(Under investigation)\n ",0]
,["Pages/Page_51550379.html#Anchor_53051949_h4_7","When Operating on Files or Directories in Write-Only sdmc Archives",
"When Operating on Files or Directories in Write-Only sdmc Archives\n \tError \tTrigger Method\n \tnn::fs::ResultNotFound \t(Under investigation)\n \tnn::fs::ResultMediaNotFound \t(Under investigation)\n \tnn::fs::ResultAlreadyExists \t(Under investigation)\n \tnn::fs::ResultArchiveInvalidated \t(Under investigation)\n \tnn::fs::ResultOperationDenied \t(Under investigation)\n \tnn::fs::ResultWriteProtected \tSlide the write-prevention tab on the SD card to \"lock\" the card.\n \tnn::fs::ResultMediaAccessError \tThis error occurs when hardware is the cause, such as when the media is making bad contact, but there is no way to reliably trigger it.\n \tnn::fs::ResultNotEnoughSpace \tReduce the amount of free space on the SD card until it is less than the size of the file you are attempting to write.\n \tUnexpected Error \t(Under investigation)\nCONFIDENTIAL\n",0]
,["Pages/Page_51556992.html","9 Infrared Communication",
"9 Infrared Communication\n",0]
,["Pages/Page_51556992.html#PageId_50890822","9.1 Power to Infrared Communication Module",
"9.1 Power to Infrared Communication Module\nPower consumption is greater when the infrared module power is turned on than when the infrared module power is off.\nIn order to conserve power, applications that do not perform infrared communication (Including use of the Circle Pad Pro) must not turn on the infrared module power. If the application does perform infrared communication, you must still turn off the infrared module power in scenes where infrared communication is not performed.\nThe infrared module power will turn on when any of the functions listed below are called. You must call the nn::ir::CTR::Communicator::Disconnect function to turn the power off.\n \tnn::ir::CTR::Communicator::RequireConnection function \tnn::ir::CTR::Communicator::WaitConnection function \tnn::ir::CTR::Communicator::AutoConnection function\nStarting with the CTR-SDK 7.x series, you can check whether the application uses infrared communication by checking whether \"NINTENDO:Ir\" is displayed in the list of middleware on the Master Editor's Basic Information (CCI) tab. If \"NINTENDO:Ir\" is not displayed, the application does not use infrared communication at all. If the application uses the nn::ir::CTR::Communicator class to directly use infrared communication, or if it uses the nn::hid::CTR::ExtraPad class for the Circle Pad Pro, \"NINTENDO:IrCommunicator\" or \"NINTENDO:ExtraPad\" will be displayed along with \"NINTENDO:Ir\".\n Infrared Communication\n nn::ir::CTR::Communicator class\n nn::ir::CTR::Communicator::RequireConnection function\n nn::ir::CTR::Communicator::WaitConnection function\n nn::ir::CTR::Communicator::AutoConnection function\n nn::ir::CTR::Communicator::Disconnect function\n Circle Pad Pro\n nn::hid::CTR::ExtraPad class\n Power consumption\n",0]
,["Pages/Page_51556992.html#PageId_51557038","9.2 Generating Communication IDs",
"9.2 Generating Communication IDs\nWhen generating communication IDs with the nn::ir::CTR::Communicator::CreateCommunicationId function for use in infrared communication between Nintendo 3DS systems, you must specify the unique ID assigned by Nintendo in the uniqueId argument.\nHowever, you must specify the same unique ID in each application that communicates, because a common communication ID is required when communicating with other applications. In these cases, it is acceptable to specify the unique ID assigned to either application.\nYou can use the IrCommunicatorChecker tool to check the unique ID passed to the function when generating communication IDs.\n Infrared Communication\n Communication IDs\n Unique IDs\n nn::ir::CTR::Communicator::CreateCommunicationId function\n IrCommunicatorChecker tool\nCONFIDENTIAL\n",0]
,["Pages/Page_83143309.html","11 System Settings",
"11 System Settings\n",0]
,["Pages/Page_83143309.html#PageId_83143437","11.1 Referencing the User Profile",
"11.1 Referencing the User Profile\nUser information (the user's profile data) is stored on each system, and it is acceptable for each application to freely choose whether to apply that user profile within the application. There are no system-side restrictions on using the accessed data.\nHowever, if your application uses the user name, be careful to avoid screen corruption and any problems impeding game progress when the user name includes characters that are not supported by the application.\nIt is acceptable to display alternate characters for characters that are not supported by the application. For example, if the application has no ability to display accented European letters, it is acceptable to replace them with similar ASCII letters or with \"?\" (question marks).\n Note:\n By using all of the system fonts, you can ensure that your application will be able to support all characters used in user profiles.\nThe country and area information can be retrieved from the user profile using the nn::cfg::GetSimpleAddress or nn::cfg::GetSimpleAddressId functions. (As referred to in this document, the system's area setting is its location within the country, such as its state, province, or prefecture.) There are no particular restrictions established regarding the use of this information, but be aware that the list of possible values could be updated, as well as the fact that some systems may not have these values set. Specifically, ensure that no problems occur if the functions return an area code (RegionID) of 0 (no area set) or 1 (countries without area codes), or a code with no corresponding supported area (in Japan this is a value of 49 or greater).\nTo test application behavior when an area code that is not supported by the firmware is set, launch the Config tool, go to UserInfoSetting, and change the Simple Address settings. However, if your application uses SpotPass downloads, take extra care when implementing the SpotPass download features, since in that case server-side specifications prevent you from testing application behavior by changing the country code (CountryID).\n Note:\n In some cases, the area code could be 1 even in countries where the system can configure area codes.\n Setting the country code or area code to an invalid value may render some network features unavailable.\nFor all scenes except those using SpotPass, you can use the following procedure to check whether problems will occur if the area information is unknown.\nLaunch the Config tool, go to UserInfoSetting, configure the Simple Address settings as shown below, and play through all modes of the application from beginning to end.\n \tStatus \tCountryID \tRegionID\n \tUnknown country code \t255 \tOptional\n \tNo area code selected \tAny valid value \t0\n \tNo area codes configurable in this country \tAny valid value \t1\n \tUnsupported area code \tAny valid value \t255\n System Settings\n User information (Profile)\n User name\n System fonts\n Country code\n CountryID\n Area code\n RegionID\n Config tool\n UserInfoSetting\n Simple Address\n nn::cfg::GetSimpleAddress function\n nn::cfg::GetSimpleAddressId function\n SpotPass\n",0]
,["Pages/Page_83143309.html#PageId_83143534","11.2 Referencing the Language Setting",
"11.2 Referencing the Language Setting\nIt is acceptable for each application to freely choose whether to apply the system's language setting within the application. There are no system-side restrictions on using the accessed data.\nAlthough it is possible to automatically reflect the system's language setting to the application's own language setting, it is also acceptable for you to allow the user to set a different language in the application-side language settings than is set in System Settings. If you do, it is not a problem if the user is able to select a language that the system doesn't support for the country currently set in System Settings.\nBecause Nintendo 3DS may support more languages in the future, attempts to get the system's language setting may return a value that is not currently defined. As a past example, Chinese and Korean were added to the language settings of the Nintendo DS after its launch.\nIf your application gets the system's language setting, take steps to avoid fatal problems such as garbled characters and lock-ups even if your application gets a language value that is not currently defined. One way to do this is to handle undefined language values as languages unsupported by the application.\n Note:\n Beginning with the CTR-SDK 10.x series, languages that are not defined in the currently in-development SDK, and languages that are not available in the current system region are no longer returned to the application. As a result, there is no need to handle unknown language settings in applications that use the CTR-SDK 10.x series or later.\n Setting the language to an invalid value may render some network features unavailable.\n Note:\n A bug has been found in Taiwanese-region consoles where the application locks up if the software keyboard is launched while the system's language setting is set to invalid. This behavior is waived at Lotcheck because the bug is not in the application.\n System Settings\n Language Setting\n Software keyboard\nCONFIDENTIAL\n",0]
];
for (var x = 0; x < additionalData.length; x++) Search.indexData.push(additionalData[x]);
Search.additionalData = additionalData;
})();
